import Vue from 'vue'
import Router from 'vue-router'
import Store from './store'
import Layout from './views/Layout.vue'
import fileNotFound from './views/errors/fileNotFound.vue'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
NProgress.configure({ showSpinner: false })

Vue.use(Router);


const originalPush = Router.prototype.push
Router.prototype.push = function push(location, onResolve, onReject) {
    if (onResolve || onReject) return originalPush.call(this, location, onResolve, onReject)
    return originalPush.call(this, location).catch(err => err)
}

const router = new Router({
    routes: [
        builder('/authentication', 'login/authentication'),
        builder('/login', 'login/login'),
        builder('/sso', 'SSO'),
        {
            path: '/',
            name: 'layout',
            component: Layout,
            meta: {
                requiresAuth: true
            },
            children: [
                ...restBuilder('oper/log', 'system/log'), // 系统管理-操作日志
                ...restBuilder('validcode', 'system/validcode'), // 接入管理-接入信息
                ...restBuilder('menu', 'system/menu'), // 系统管理--菜单管理
                ...restBuilder('resource', 'system/resource'), // 系统管理--资源管理
                ...restBuilder('role', 'system/role'), // 系统管理--角色管理
                ...restBuilder('user', 'system/user'), // 用户管理 -- 管理用户
                ...restBuilder('param', 'system/param'), // 系统管理--参数管理
                ...restBuilder('task', 'system/task'), // 系统管理--任务管理


                //模块配置
                ...restBuilder('dept', 'dept'),
                ...restBuilder('realtime/dataflow', 'realtime/dataflow'),//人员发现
                ...restBuilder('appointment/records', 'appointment/records'), //预约签到记录表
                ...restBuilder('care/records', 'care/records'),//预约关怀记录表
                ...restBuilder('appointment/config', 'appointment/config'), //预约签到配置
                ...restBuilder('appointment/config/times', 'appointment/config/times'), //预约自动签到配置时间段
                ...restBuilder('care/config', 'care/config'), //主动关怀配置
                ...restBuilder('care/config/times', 'care/config/times'), //主动关怀时间段
                ...restBuilder('appointment/constraint', 'appointment/constraint'), //预约自动签到服务约束
                ...restBuilder('care/constraint', 'care/constraint'), //主动关怀服务约束
                ...restBuilder('care/constraint/track', 'care/constraint/track'), //主动关怀服务追踪
                ...restBuilder('care/constraint/track', 'care/constraint/track'), //主动关怀服务追踪
                ...restBuilder('person', 'person'), //注册人员
                ...restBuilder('device', 'device'), //设备业务
                ...restBuilder('notice', 'notice'), //消息
                ...restBuilder('monitor/alarm', 'monitor/alarm'), //监控预警
                ...restBuilder('monitor/alarm/record', 'monitor/alarm/record'), //监控预警记录
                ...restBuilder('face/plan', 'face/plan'), //人员识别计划


                //以下为基础路由配置
                builder('blank', 'blank'),
                builder('', 'Home'),
                builder('index', 'Home'),
                builder('login/updatePwd', 'login/updatePwd'),
                builder('403', 'errors/403'),
                builder('*', 'errors/404'),
            ]
        },
    ]
})

/**
 * rest路由生成器
 *
 * @param {string} path 路径
 * @param {string} [component=path] 文件地址
 * @returns {array} [] reset路由数组，包含list/edit/add/view
 */
function restBuilder(path, component = path) {
    let arr = [];
    arr.push(builder(`${path}/list`, `${component}/list`));
    arr.push(builder(`${path}/edit`, `${component}/show`));
    arr.push(builder(`${path}/add`, `${component}/show`));
    arr.push(builder(`${path}/view`, `${component}/view`));
    return arr;
}

/**
 * 路由生成器
 *
 * @param {string} path 路径
 * @param {string} [component=path] 文件地址
 * @param {boolean} [requiresAuth=false] 是否登录后才能访问
 * @returns {any} {} 路由对象
 */
function builder(path, component = path, requiresAuth = false) {
    return {
        path: path,
        name: path || 'homepage',
        component: getComponent(component),
        meta: {
            requiresAuth: requiresAuth
        }
    }
}

function getComponent(fileName) {
    try {
        return require('./views/' + fileName).default
    } catch (error) {
        return fileNotFound;
    }
}
//检查是否跳转到sso地址
function ssoCheck(to, from, next) {
    console.log("to", to)
    console.log("from", from)
    console.log("next", next)
    let redirect = (to.path === '/login/updatePwd') ? '/#/updatePwd' : ''
    redirect = (redirect === '' && to.path === '/login') ? (location.protocol + '//' + location.host + '/#' + from.fullPath) : redirect
    if (redirect != '') {
        next(false)
        window.location.href = '//' + location.host + '/m/login/logout?redirect=' + encodeURIComponent(redirect)
        return true;
    }
    return false;
}

router.afterEach(() => {
    document.body.scrollTop = 0
    document.documentElement.scrollTop = 0
    NProgress.done()
})

// 路由鉴权
router.beforeEach((to, from, next) => {
    // if (ssoCheck(to, from, next)) { //sso鉴权检查
    //   return
    // }
    NProgress.start()
    if (to.matched.some(record => record.meta.requiresAuth)) {
        if (Store.state.isLogin) {
            next();
        } else {
            next({
                path: '/authentication',
                query: {
                    redirect: to.fullPath
                }
            })
        }
    } else {
        next();
    }
})


export default router;
